<?php

/*#### #### #### #### #### #### #### #### #### ####
phpLogCon - A Web Interface to Log Data.
Copyright (C) 2004-2005  Adiscon GmbH



This program is free software; you can redistribute it and/or modify it
under the terms of the GNU General Public License as published by the
Free Software Foundation; either version 2 of the License, or (at your
option) any later version.

This program is distributed in the hope that it will be useful, 
but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or 
FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; 
if not, write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston, 
MA  02111-1307, USA.

If you have questions about phpLogCon in general, please email info@adiscon.com. 
To learn more about phpLogCon, please visit http://www.phplogcon.com.

This Project was intiated and is maintened by Rainer Gerhards <rgerhards@hq.adiscon.com>. 
See AUTHORS to learn who helped make it become a reality.

*/#### #### #### #### #### #### #### #### #### #### 

	/*! \addtogroup Layout
	*
	* Here you find the basic structure of the page layout. Changes in the
	* following function take affect in the hole phpLogCon projeckt. Note,
	* the basic structure of each phpLogCon page must be generated by the
	* use of the WriteHead() and WriteFooter(). If you make a new phpLogCon
	* page, first call WriteHead(). This function generate the hole header
	* of the page. WriteHead() itself calls functions to generate the top
	* menu bar (MenuTop()) and the menu on the left side (MenuLeft()).
	* After this function call you are in the main work area. There you
	* can provide your content information. To finialize the page, call
	* WriteFooter(). This generates the footer on the bottom of the page.
	*  @{ 
	*/
  
  /*!
  *
  */ 


	/*!
	* generate the url for pint version
	* /return The Url refer to the pint version of the current page.
	*/

	// very important to include config settings at beginning! (enable header setting)
	// include 'config.php';

	function GetPrinterURL()
	{
		global $PHP_SELF, $QUERY_STRING;

		$szURL = $PHP_SELF . "?";
		if(strlen($QUERY_STRING) > 0)
			$szURL .= $QUERY_STRING . "&";
		$szURL .= "PrinterVersion=1";

		return($szURL);
	} //end function GetPrintUrl()

	/*!
	 * Display logo and provide the link to change to print version. ...    
	 * This things are displayed on the top of the page.                    
	 *
	 * Menu Top is called by WriteHead()
	 *
	 * \param SiteName This String is displayed on the top of the page (it is visible output!)
	 * \sa WriteHead()                             
	 */
	function MenuTop($SiteName)
	{
		global $strBasePath, $strBaseRealPath, $PrinterVersion;

?>

<table align="center" width="100%" cellspacing="0" cellpadding="0" border="0" CLASS="EventTable">	
	<tr>
		<?php
			if (_ENABLEHEADER == "1")
			{
				echo "<td width=\"220\" align=\"left\"><img src=\"",_ADLibPathImage,"phplogcon.gif\" border=\"0\"></td>
				<td align=\"left\">
				<h1>phpLogCon monitoring</h1>
				</td>";
			}
		?>
	</tr>
</table>
    
<table align="center" width="100%" cellspacing="0" cellpadding="0" border="0" CLASS="EventTable">
  	<tr>
  		<td align="left">
			<a href="index.php"><?php echo _MSGHom; ?></a> | <a href="events-display.php"><?php echo _MSGShwEvn; ?></a>
			| <a href="syslog-index.php"><?php echo _MSGShwSlt; ?></a>
			| <a href="filter-config.php"><?php echo _MSGFOpt; ?></a> | <a href="user-config.php"><?php echo _MSGUOpt; ?></a> | <a href="database-config.php"><?php echo _MSGDbOpt; ?></a> | 
			<a href="
			<?php echo  $_SERVER['PHP_SELF'];
			   $i = strpos($_SERVER['REQUEST_URI'], '?');
			   if ($i>0)
				   echo substr($_SERVER['REQUEST_URI'], $i);
			   ?>
			">
			<?php echo _MSGRef; ?></a> | <a href="doc/index.htm" target="_blank"><?php echo _MSGHlp; ?></a>
			<?php if($_SESSION['debug'] == 1)echo _MSGMenInf1 . "<font color=\"red\">" . strtoupper(_CON_MODE) . "</font>" . _MSGMenInf2 . "<font color=\"red\">" . strtoupper(_DB_APP) . "</font>" . _MSGMenInf3 . "<font color=\"red\">" . strtoupper(_DBNAME) . "</font>";?>
		</td>
  		<td align="left">&nbsp;</td>
		<td align="right">
  		<b><font ID="HeadTitle" class="HeadTitle"><?php echo $SiteName; ?></font></b>
  		</td>
  	</tr>
</table>

<?php

	} // END MenuTop()
   
   
	/*!
	 * It generates the head of the document. All things between the introducing html - Tag and body - Tag 
	 * is generated by this function, e. g. Meta Description, ...
	 *
	 * WriteHead call the the functions: MenuTop($SiteName) and MenuLeft()
	 *
	 * \param strTitle Title of the current page (used for the title - Tag)
	 * \param strKeywords Additional keywords, especially for the current page (used for Meta Tag)
	 * \param strDescr A description of the current page (used for Meta Tag)
	 * \param SiteName This String is displayed on the top of the page (it is visible output!) 
	 * \sa MenuTop($SiteName), MenuLeft()                                
	 */
	function WriteHead($strTitle, $strKeywords, $strDescr, $SiteName)
	{
		global $stylesheet;

?>

		<html>
		<head>
			<title><?php echo $strTitle; ?></title>
			<META NAME="robots" CONTENT="INDEX,FOLLOW">
			<META NAME="copyright" CONTENT="Copyright (C) 2003 Adiscon GmbH, Erftstadt - www.adiscon.com">
			<META name="Keywords" content="<?php echo $strKeywords ?> sql server win NT windows 7 2000 replication merge nt transactional date time resolver">
			<META http-equiv="pragma" CONTENT="no-cache">

<?php
	
		if(strlen($strDescr) > 0)
		{ 
			echo "<meta name=\"Description\" content=\"".$strDescr."\">";
		} 
    
    // if refresh enabled, make a meta redirect
    if ($_SESSION['refresh'] > 0) 
      					echo '<meta HTTP-EQUIV="REFRESH" CONTENT="', $_SESSION['refresh'], '; URL=', $_SERVER['PHP_SELF'], '?', $_SERVER['QUERY_STRING'], '">'; 

?>

<link rel="stylesheet" href="<?php echo _ADLibPathScript . $_SESSION['stylesheet']; ?>.css" type="text/css">
<?php echo '<script language="JavaScript" src="' . _ADLibPathScript . 'common.js"></script>'; ?>
</head>
<body>
<script src="<?php echo _ADLibPathScript . $_SESSION['stylesheet']; ?>.js"></script>

<?php
	MenuTop($SiteName);
	}	// END of  WriteHead() function 


	/*!
	* The footer holds some general information.                           
	*/
	function WriteFooter()
	{ 
		global $strBasePath, $strBaseRealPath, $PrinterVersion, $global_Con;

?>

<center>
<table>
<tr>
	<td>
		<br /><br />
		<small><i><a href="http://www.phplogcon.com/" target="_blank">phpLogCon</a>, Copyright &copy; 2003 - 2005 <a href="http://www.adiscon.com" target="_blank">Adiscon GmbH</a></i></small>
	</td>
</tr>
</table>
</center>
</body>
</html>

<?php

	// Close Database connection ONCE
	db_close($global_Con);
	
	} // END function WriteFooter() 

?>